s_mem_loc_list find_lvalue (s_state * curr_state, tree l_var) {
	s_mem_loc_list  return_mem;
	s_mem_loc_list curr_memory;
	int found;
	s_mem_loc * curr_mem_location;
	
	//printf ("find lvalue\n"); 
	return_mem = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
	switch (TREE_CODE (l_var)) {
		case VAR_DECL:
		case PARM_DECL:
		case RESULT_DECL:
		{
			curr_memory = curr_state->memory;
			found = 0;
			while (!found && curr_memory != NULL) {
				curr_mem_location = curr_memory->location;	
				if (curr_mem_location->var == l_var) {
					found = 1;
					return_mem = curr_memory;
					
				} else {
					curr_memory = curr_memory->next;
				}
			}
			if (!found) {
				return_mem = NULL;
			}
		}
			break;
		case COMPONENT_REF:
		{
			int round;
			tree struct_var, field;
			tree p;
			/* currently I am assuming compref can be of type struct.field */
			/*for (p = l_var; TREE_CODE (p) == COMPONENT_REF; p = TREE_OPERAND (p, 0)) {
				struct_var = TREE_OPERAND (p, 0);
				field = TREE_OPERAND (p, 1); 
			}*/
			/* search the struct varibale in the memory list */
			/*
			curr_memory = curr_state->memory;
			found = 0;
			while (!found && curr_memory != NULL) {
				curr_mem_location = curr_memory->location;	
				if (curr_mem_location->var == struct_var) {
					found = 1;
				} else {
					curr_memory = curr_memory->next;
				}
			}
			*/
			field = TREE_OPERAND (l_var, 1);
			p = TREE_OPERAND (l_var, 0);
			curr_memory = find_lvalue (r_curr_state, p);
			/* find the field of the structure now */
			found = 0;
			while (!found && curr_memory != NULL) {
				curr_mem_location = curr_memory->location;	
				if (curr_mem_location->var == field) {
					found = 1;
					return_mem = curr_memory;
					
				} else {
					curr_memory = curr_memory->next;
				}
			}
			if (!found) {
				return_mem = NULL;
			}
				
		}
			break;
		case ARRAY_REF:
		{
			int round=0;
			struct array_ref * array_ref_list = NULL;
			struct array_ref * temp_array_ref;
			struct array_ref * prev_array_ref = NULL;
			s_mem_loc * current_location;
			s_mem_loc_list current_heap;
			tree p;

			for (p = l_var; TREE_CODE (p) == ARRAY_REF; p = TREE_OPERAND (p, 0)) {
				temp_array_ref = (struct array_ref *) xmalloc (sizeof (struct array_ref));
				temp_array_ref->op1 = TREE_OPERAND (p, 1); 
				temp_array_ref->kind = 0;
				temp_array_ref->next = array_ref_list;
				array_ref_list = temp_array_ref;
			}
			/* search the array varibale in the memory list */
			/*
			curr_memory = curr_state->memory;
			found = 0;
			while (!found && curr_memory != NULL) {
				curr_mem_location = curr_memory->location;	
				if (curr_mem_location->var == p) {
					found = 1;
					return_mem  = curr_memory;
					
				} else {
					curr_memory = curr_memory->next;
				}
			}
			*/
			return_mem = find_lvalue (r_curr_state, p);
			/* variable is just array, no array reference*/
			if (array_ref_list == NULL) {
				fprintf (stdout, "Just passed array name in ARRAR_REF ");
				exit (0);
			}
			round = 0;
			while (array_ref_list != NULL){
				s_value * array_index_value;
				int curr_index;
				int i;

				array_index_value = find_rvalue (r_curr_state, array_ref_list->op1);
				if (array_index_value != NULL) {
					curr_index = array_index_value->value.int_val;
				}
				if (round == 0) {
					current_heap = return_mem->location->val->value.heap_val;
					round++;
				} else { 
					current_heap = current_location->val->value.heap_val;
				}
				for (i = 1; i<=curr_index; i++) {
					if (TREE_CODE (TREE_TYPE (l_var)) == RECORD_TYPE) {
						current_heap = current_heap->location->next_struct;
					} else {
						current_heap = current_heap->next;
					}
				}
				current_location = current_heap->location;
				array_ref_list = array_ref_list->next;				
			}
			return_mem = current_heap;	
		}
			break;
		case INDIRECT_REF:
		{
			tree p;

			p = TREE_OPERAND (l_var, 0);
			curr_memory = curr_state->memory;
			found = 0;
			while (!found && curr_memory != NULL) {
				curr_mem_location = curr_memory->location;	
				if (curr_mem_location->var == p) {
					found = 1;
					return_mem = curr_mem_location->val->value.heap_val;
					
				} else {
					curr_memory = curr_memory->next;
				}
			}
			if (!found) {
				return_mem = NULL;
			}
		}
			break;
		default:
			return_mem = NULL;
			break;
	}
	return return_mem;
} 
