#define BINARY_OPERATION()\
{\
	s_value * rhs0;\
	s_value * rhs1;\
	rhs0 = find_rvalue (curr_state, TREE_OPERAND (r_var, 0));\
	rhs1 = find_rvalue (curr_state, TREE_OPERAND (r_var, 1));\
	if ((rhs0 && rhs0->kind == INT_KIND) || (rhs1 && rhs1->kind == INT_KIND)) {\
		return_val->value.int_val = rhs0->value.int_val OPERATOR rhs1->value.int_val;\
		return_val->kind = INT_KIND;\
	}\
	if ((rhs0 && rhs0->kind == FLOAT_KIND) || (rhs1 && rhs1->kind == FLOAT_KIND)) {\
		return_val->value.float_val = rhs0->value.float_val OPERATOR rhs1->value.float_val;\
		return_val->kind = FLOAT_KIND;\
	}\
	if ((rhs0 && rhs0->kind == BOOL_KIND) || (rhs1 && rhs1->kind == BOOL_KIND)) {\
		return_val->value.bool_val = rhs0->value.bool_val OPERATOR rhs1->value.bool_val;\
		return_val->kind = BOOL_KIND;\
	}\
}


#define CHECK_HASH_TABLE()\
{\
	int a1;\
	int a2;\
	int a3;\
	int a4;\
	if (current_process == main_process)\
	{\
		if (child_process != NULL) {\
			r_other_state = child_process->process_state;\
		}else {\
			r_other_state = NULL;\
		}\
	}\
	else\
	{\
		if (main_process != NULL) {\
			r_other_state = main_process->process_state;\
		}else {\
			r_other_state = NULL;\
		}\
	}\
	a1 = r_curr_state->proc->proc_number;\
	a2 = r_curr_state->node->node_number;\
	if (r_other_state == NULL){\
		a3 = -1;\
		a4 = -1;\
	}\
	else {\
		a3 = r_other_state->proc->proc_number;\
		a4 = r_other_state->node->node_number;\
	}\
	r_hash_table_entry = generate_hash_table_entry (r_curr_state, a1, a2, r_other_state, a3, a4);\
	cdata = (int *) pblHtLookup (state_hash_table, (void *) r_hash_table_entry, sizeof (int)*400);\
	if (cdata == NULL){\
		pblHtInsert(state_hash_table, (void*)r_hash_table_entry, sizeof(int)*400, (void*)r_hash_table_entry);\
	}\
	else\
	{\
		printf ("same state has already been visited\n");\
		exit(1);\
	}\
}

