#include <verisoft.h>

/****************************************************************************
 * phil.c : dining philosophers with 1 deadlock                             *
 ****************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h> 
#include <sys/sem.h> 

#define N 5


philosopher(i,semid)
     int i, semid;
{
  while (1)
    {
      printf("philosopher %d thinks\n",i); 
      semwait(semid,i,1);
      semwait(semid,((i+1)%N),1);
      printf("philosopher %d eats\n",i); 
      semsignal(semid,i,1);
      semsignal(semid,((i+1)%N),1);
    }

}


main()
{
  int semid, i, pid, status;

  semid = semget(IPC_PRIVATE,N,0600);

  for(i=0;i<N;i++)
    semsetval(semid,i,1);

  for(i=0;i<(N-1);i++)
    {
      if((pid=fork()) == 0)
	{
	  philosopher(i,semid);
	}
    };
  philosopher(i,semid);
}



