void clone_memory_heap_while_function_call_or_return (s_state * curr_state, s_state * next_state) {
	int count;
	s_mem_loc_list curr_memory;
	s_mem_loc_list next_memory;
	s_mem_loc_list temp_memory;
	s_mem_loc *temp_location;
	s_mem_loc *curr_location;
	tree params;
	struct var_list * temp_locals_list; 

	//mm_memory = mm_memory + sizeof (s_state);
	next_state->freed = 0;
	//printf ("clone_memory_heap_while_function_call_or_return\n");
	next_state->number = 0;
	next_state->heap = NULL;
	next_state->memory = NULL;
	next_state->stmt = curr_proc->cfg_array[0]->insn;
	next_state->proc = curr_proc;
	curr_cfg_node = curr_proc->cfg_array[0];
	next_state->node = curr_cfg_node;
	last_allocated_memory = NULL;
	last_allocated_heap = NULL;
	count = 0;
	next_memory = NULL;
	curr_memory = curr_state->memory;
	while (curr_memory != NULL && curr_memory->location->var != NULL) {
		temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
		mm_memory = mm_memory + sizeof (struct my_mem_list);
		curr_location = curr_memory->location;
		temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
		mm_memory = mm_memory + sizeof (s_mem_loc);
		temp_location->val = NULL;
		temp_location->var = curr_location->var; 
		temp_location->next_struct = curr_location->next_struct; 
		temp_location->kind = curr_location->kind; 
		if (curr_location->val != NULL) {
			temp_location->val = (s_value *) xmalloc (sizeof (s_value));
			mm_memory = mm_memory + sizeof (s_value);
			if (curr_location->val->kind == INT_KIND) {
				temp_location->val->value.int_val = curr_location->val->value.int_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = INT_KIND;
			} else if (curr_location->val->kind == FLOAT_KIND) {
				temp_location->val->value.float_val = curr_location->val->value.float_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = FLOAT_KIND;
			}
			else if (curr_location->val->kind == BOOL_KIND) {
				temp_location->val->value.bool_val = curr_location->val->value.bool_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = BOOL_KIND;
			}
			else if (curr_location->val->kind == MEM_KIND) {
				temp_location->val->value.mem_val = curr_location->val->value.mem_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = MEM_KIND;
			}
			else if (curr_location->val->kind == HEAP_KIND) {
				temp_location->val->value.heap_val = curr_location->val->value.heap_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = HEAP_KIND;
			}
		} 
		else {
			temp_location->val = NULL;
			temp_location->points_to_index = -1; 
		}
		
		temp_memory->location = temp_location;
		temp_memory->next = NULL;
		if (count == 0) {
			next_memory = temp_memory;
			next_state->memory = temp_memory;
			count = 1;
		} else {
			next_memory->next = temp_memory;
			next_memory = temp_memory;
		}
		curr_memory = curr_memory->next;	
	}
	temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
	mm_memory = mm_memory + sizeof (struct my_mem_list);
	temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
	mm_memory = mm_memory + sizeof (s_mem_loc);
	temp_location->var = NULL;  //This is to find that global variables are done before this
	temp_location->kind = G;
	temp_location->points_to_index = -1; 
	temp_location->val = NULL;
	temp_location->next_struct = NULL;
	temp_memory->location = temp_location;
	temp_memory->next = NULL;
	
	if (count == 0) {
		next_memory = temp_memory;
		next_state->memory = temp_memory;
		count = 1;
	} else {
		next_memory->next = temp_memory;
		next_memory = temp_memory;
	}
	/* we need to renew the last_allocated_memory everytime we clone the memory */
	temp_memory = next_state->memory; 		
	last_allocated_memory = temp_memory;
	while (temp_memory != NULL) {
		last_allocated_memory = temp_memory;
		temp_memory = temp_memory->next;
	}

	r_curr_state = next_state;
	clone_heap (curr_state, next_state);
	params = DECL_ARGUMENTS (curr_proc->proc);	
	while (params) {
		s_mem_loc_list temp_memory;

		if (TREE_CODE (TREE_TYPE (params)) == RECORD_TYPE) {
			allocate_memory_for_records (params, L);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			mm_memory = mm_memory + sizeof (struct my_mem_list);
			temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			mm_memory = mm_memory + sizeof (s_mem_loc);
			temp_location->var = params;
			temp_location->kind = L;
			temp_location->points_to_index = -1; //initialize
			temp_location->val = create_value_structure (TREE_TYPE (params));	
			temp_location->next_struct = NULL;
			if (temp_location->val && temp_location->val->kind == HEAP_KIND) {
				temp_location->points_to_index = (temp_location->val->value.heap_val)->location->index;
			}
			temp_memory->location = temp_location;
			temp_memory->next = NULL;
			if (last_allocated_memory == NULL) {
				last_allocated_memory = temp_memory ;
				//r_curr_state->memory = temp_memory;
				next_state->memory = temp_memory;
			} else {
				last_allocated_memory->next = temp_memory;
				last_allocated_memory = temp_memory;
			}
		}
		params = TREE_CHAIN (params);
	}
	temp_locals_list = curr_proc->vars;
 	while (temp_locals_list != NULL) {
		s_mem_loc_list temp_memory;

		if (TREE_CODE (TREE_TYPE (temp_locals_list->var)) == RECORD_TYPE) {
			allocate_memory_for_records (temp_locals_list->var, L);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			mm_memory = mm_memory + sizeof (struct my_mem_list);
			temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			mm_memory = mm_memory + sizeof (s_mem_loc);
			temp_location->var = temp_locals_list->var;
			temp_location->kind = L;
			temp_location->points_to_index = -1; //initialize
			temp_location->val = create_value_structure (TREE_TYPE (temp_locals_list->var));	
			temp_location->next_struct = NULL;
			if (temp_location->val && temp_location->val->kind == HEAP_KIND) {
				temp_location->points_to_index = (temp_location->val->value.heap_val)->location->index;
			}
			temp_memory->location = temp_location;
			temp_memory->next = NULL;
			if (last_allocated_memory == NULL) {
				last_allocated_memory = temp_memory ;
				//r_curr_state->memory = temp_memory;
				next_state->memory = temp_memory;
			} else {
				last_allocated_memory->next = temp_memory;
				last_allocated_memory = temp_memory;
			}
		}
		temp_locals_list = temp_locals_list->next;
	}	
	//printf ("finished clone_memory_heap_while_function_call_or_return\n");
}

void clone_memory (s_state * curr_state, s_state * next_state) {
	int count;
	s_mem_loc_list curr_memory;
	s_mem_loc_list next_memory;
	s_mem_loc_list temp_memory;

	//printf ("clone_memory\n");
	count = 0;
	next_memory = NULL;
	curr_memory = curr_state->memory;
	while (curr_memory != NULL) {
		s_mem_loc *temp_location;
		s_mem_loc *curr_location;

		temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
		mm_memory = mm_memory + sizeof (struct my_mem_list);
		curr_location = curr_memory->location;
		temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
		mm_memory = mm_memory + sizeof (s_mem_loc);
		temp_location->val = NULL;
		temp_location->var = curr_location->var; 
		temp_location->next_struct = curr_location->next_struct; 
		temp_location->kind = curr_location->kind; 
		if (curr_location->val != NULL) {
			temp_location->val = (s_value *) xmalloc (sizeof (s_value));
			mm_memory = mm_memory + sizeof (s_value);
			if (curr_location->val->kind == INT_KIND) {
				temp_location->val->value.int_val = curr_location->val->value.int_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = INT_KIND;
			} else if (curr_location->val->kind == FLOAT_KIND) {
				temp_location->val->value.float_val = curr_location->val->value.float_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = FLOAT_KIND;
			}
			else if (curr_location->val->kind == BOOL_KIND) {
				temp_location->val->value.bool_val = curr_location->val->value.bool_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = BOOL_KIND;
			}
			else if (curr_location->val->kind == MEM_KIND) {
				temp_location->val->value.mem_val = curr_location->val->value.mem_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = MEM_KIND;
			}
			else if (curr_location->val->kind == HEAP_KIND) {
				temp_location->val->value.heap_val = curr_location->val->value.heap_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = HEAP_KIND;
			}
		} 
		else {
			temp_location->val = NULL;
			temp_location->points_to_index = -1; 
		}
		
		temp_memory->location = temp_location;
		temp_memory->next = NULL;
		if (count == 0) {
			next_memory = temp_memory;
			next_state->memory = temp_memory;
			count = 1;
		} else {
			next_memory->next = temp_memory;
			next_memory = temp_memory;
		}
		curr_memory = curr_memory->next;	
	}
	/* we need to renew the last_allocated_memory everytime we clone the memory */
	temp_memory = next_state->memory; 		
	last_allocated_memory = temp_memory;
	while (temp_memory != NULL) {
		last_allocated_memory = temp_memory;
		temp_memory = temp_memory->next;
	}
}

void clone_heap (s_state * curr_state, s_state * next_state) {
	int count;
	s_mem_loc_list curr_heap;
	s_mem_loc_list curr_heap1;
	s_mem_loc_list curr_memory1;
	s_mem_loc_list curr_heap2;
	s_mem_loc_list next_heap;
	s_mem_loc_list temp_heap;
	s_mem_loc_list stored_heap_of_next_state;
	
	//printf ("cloning heap\n");
	count = 0;
	if (next_state != NULL) {
		stored_heap_of_next_state = next_state->heap;
	}
	next_heap = NULL;
	curr_heap = curr_state->heap;
	while (curr_heap != NULL) {
		s_mem_loc *temp_location;
		s_mem_loc *curr_location;

		temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
		mm_memory = mm_memory + sizeof (struct my_mem_list);
		curr_location = curr_heap->location;
		temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
		mm_memory = mm_memory + sizeof (s_mem_loc);
		temp_location->val = NULL;
		temp_location->var = curr_location->var; 
		temp_location->next_struct = curr_location->next_struct; 
		temp_location->index = curr_location->index; 
		if (curr_location->val != NULL) {
			temp_location->val = (s_value *) xmalloc (sizeof (s_value));
			mm_memory = mm_memory + sizeof (s_value);
			if (curr_location->val->kind == INT_KIND) {
				temp_location->val->value.int_val = curr_location->val->value.int_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = INT_KIND;
			}
			else if (curr_location->val->kind == FLOAT_KIND) {
				temp_location->val->value.float_val = curr_location->val->value.float_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = FLOAT_KIND;
			}
			else if (curr_location->val->kind == BOOL_KIND) {
				temp_location->val->value.bool_val = curr_location->val->value.bool_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = BOOL_KIND;
			}
			else if (curr_location->val->kind == MEM_KIND) {
				temp_location->val->value.mem_val = curr_location->val->value.mem_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = MEM_KIND;
			}
			else if (curr_location->val->kind == HEAP_KIND) {
				temp_location->val->value.heap_val = curr_location->val->value.heap_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = HEAP_KIND;
			}
		} else {
			temp_location->val = NULL;
			temp_location->points_to_index = -1; 
		}
		temp_heap->location = temp_location;
		temp_heap->next = NULL;
		if (count == 0) {
			next_heap = temp_heap;
			next_state->heap = temp_heap;
			count = 1;
		} else {
			next_heap->next = temp_heap;
			next_heap = temp_heap;
		}
		if (stored_heap_of_next_state != NULL) {
			stored_heap_of_next_state = stored_heap_of_next_state->next;
		}
		curr_heap = curr_heap->next;	
	}
	/*
	while (stored_heap_of_next_state != NULL) {
		s_mem_loc *temp_location;
		s_mem_loc *curr_location;

		temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
		curr_location = stored_heap_of_next_state->location;
		temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
		temp_location->val = (s_value *) xmalloc (sizeof (s_value));
		temp_location->var = curr_location->var; 
		temp_location->next_struct = curr_location->next_struct; 
		temp_location->index = curr_location->index; 
		if (curr_location->val != NULL) {
			if (curr_location->val->kind == INT_KIND) {
				temp_location->val->value.int_val = curr_location->val->value.int_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = INT_KIND;
			}
			if (curr_location->val->kind == FLOAT_KIND) {
				temp_location->val->value.float_val = curr_location->val->value.float_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = FLOAT_KIND;
			}
			if (curr_location->val->kind == BOOL_KIND) {
				temp_location->val->value.bool_val = curr_location->val->value.bool_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = BOOL_KIND;
			}
			if (curr_location->val->kind == MEM_KIND) {
				temp_location->val->value.mem_val = curr_location->val->value.mem_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = MEM_KIND;
			}
			if (curr_location->val->kind == HEAP_KIND) {
				temp_location->val->value.heap_val = curr_location->val->value.heap_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = HEAP_KIND;
			}
		} else {
			temp_location->val = NULL;
			temp_location->points_to_index = -1; 
		}
		temp_heap->location = temp_location;
		temp_heap->next = NULL;
		if (count == 0) {
			next_heap = temp_heap;
			next_state->heap = temp_heap;
			count = 1;
		} else {
			next_heap->next = temp_heap;
			next_heap = temp_heap;
		}
		stored_heap_of_next_state = stored_heap_of_next_state->next;	
	}
	*/
	
	/* we need to renew the last_allocated_heap everytime we clone the heap */
	temp_heap = next_state->heap; 		
	last_allocated_heap = temp_heap;
	while (temp_heap != NULL) {
		last_allocated_heap = temp_heap;
		temp_heap = temp_heap->next;
	}
	/* copying the links of heap locations */
	/* if a heap location is pointing to another heap location, then find that link and put into first's value */
	curr_heap1 = next_state->heap;
	while (curr_heap1 != NULL) {
		int i;
		if (curr_heap1->location->points_to_index >0){
			curr_heap2 = next_state->heap;
			i = 0;
			while (curr_heap2 != NULL && i!= curr_heap1->location->points_to_index) {
				curr_heap2 = curr_heap2->next;
				i++;
			}
			
			if (i == curr_heap1->location->points_to_index) {
				curr_heap1->location->val->value.heap_val = curr_heap2;
			}
		} 
		curr_heap1 = curr_heap1->next;
	}
	/* copying the links of memory locations */
	/* if a memory location is pointing to another heap location, then find that link and put into first's value */
	curr_memory1 = next_state->memory;
	while (curr_memory1 != NULL) {
		int i;

		if (curr_memory1->location->points_to_index >=0){
			curr_heap2 = next_state->heap;
			i = 0;
			while (curr_heap2 != NULL && i!= curr_memory1->location->points_to_index) {
				curr_heap2 = curr_heap2->next;
				i++;
			}
			
			if (i == curr_memory1->location->points_to_index) {
				curr_memory1->location->val->value.heap_val = curr_heap2;
			}
		} 
		curr_memory1 = curr_memory1->next;
	}
	
	/*copy the next_srtuct field */
	curr_heap1 = next_state->heap;
	while (curr_heap1 != NULL) {
		int i;
		int index;
		if (curr_heap1->location->next_struct){
			i = 0;
			index = curr_heap1->location->next_struct->location->index;
			curr_heap2 = next_state->heap;
			while (curr_heap2 != NULL && i!= index) {
				curr_heap2 = curr_heap2->next;
				i++;
			}
			
			if (i == index ) {
				curr_heap1->location->next_struct = curr_heap2;
			}
		} 
		curr_heap1 = curr_heap1->next;
	}
	/* here we will have to copy the next struct field for memory too
	  if it is needed in memory */
}

void clone_state (s_state *curr_state, s_state *next_state) {
	int i;
	next_state->number = curr_state->number + 1;
	next_state->stmt = NULL;	
	next_state->memory = NULL;
	next_state->heap = NULL;
	next_state->proc = curr_state->proc;
	next_state->node = curr_state->node;
	clone_memory (curr_state, next_state);
	//next_state->memory = curr_state->memory;
	clone_heap (curr_state, next_state);
	//next_state->heap = curr_state->heap;
	next_state->return_state = curr_state->return_state;
	next_state->freed = 0;
	next_state->return_stack_length = curr_state->return_stack_length;
	for (i=0; i<MAX_RETURN_STACK_SIZE; i++) {
		next_state->return_stack[i] = curr_state->return_stack[i];
	}
	return;
}
