#define BINARY_OPERATION()\
{\
	s_value * rhs0;\
	s_value * rhs1;\
	rhs0 = find_rvalue (curr_state, TREE_OPERAND (r_var, 0));\
	rhs1 = find_rvalue (curr_state, TREE_OPERAND (r_var, 1));\
	if ((rhs0 && rhs0->kind == INT_KIND) || (rhs1 && rhs1->kind == INT_KIND)) {\
		return_val = (s_value *) xmalloc (sizeof (s_value));\
		mm_memory = mm_memory + sizeof (s_value);\
		return_val->value.int_val = rhs0->value.int_val OPERATOR rhs1->value.int_val;\
		return_val->kind = INT_KIND;\
		if (rhs0) {\
			free (rhs0);\
			mf_memory = mf_memory + sizeof (s_value);\
			rhs0 = NULL;\
		}\
		if (rhs1) {\
			free (rhs1);\
			mf_memory = mf_memory + sizeof (s_value);\
			rhs1 = NULL;\
		}\
	}else if ((rhs0 && rhs0->kind == FLOAT_KIND) || (rhs1 && rhs1->kind == FLOAT_KIND)) {\
		return_val = (s_value *) xmalloc (sizeof (s_value));\
		mm_memory = mm_memory + sizeof (s_value);\
		return_val->value.float_val = rhs0->value.float_val OPERATOR rhs1->value.float_val;\
		return_val->kind = FLOAT_KIND;\
		if (rhs0) {\
			free (rhs0);\
			mf_memory = mf_memory + sizeof (s_value);\
			rhs0 = NULL;\
		}\
		if (rhs1) {\
			free (rhs1);\
			mf_memory = mf_memory + sizeof (s_value);\
			rhs1 = NULL;\
		}\
	}else if ((rhs0 && rhs0->kind == BOOL_KIND) || (rhs1 && rhs1->kind == BOOL_KIND)) {\
		return_val = (s_value *) xmalloc (sizeof (s_value));\
		mm_memory = mm_memory + sizeof (s_value);\
		return_val->value.bool_val = rhs0->value.bool_val OPERATOR rhs1->value.bool_val;\
		return_val->kind = BOOL_KIND;\
		if (rhs0) {\
			free (rhs0);\
			mf_memory = mf_memory + sizeof (s_value);\
			rhs0 = NULL;\
		}\
		if (rhs1) {\
			free (rhs1);\
			mf_memory = mf_memory + sizeof (s_value);\
			rhs1 = NULL;\
		}\
	}\
}

#define CHECK_HASH_TABLE_OLD()\
{\
	int a1;\
	int a2;\
	int a3;\
	int a4;\
	int * temp_entry;\
	int i;\
	if (current_process == main_process){\
		if (child_process != NULL) {\
			r_other_state = child_process->process_state;\
		}else {\
			r_other_state = NULL;\
		}\
	}else {\
		if (main_process != NULL) {\
			r_other_state = main_process->process_state;\
		}else {\
			r_other_state = NULL;\
		}\
	}\
	a1 = r_curr_state->proc->proc_number;\
	a2 = r_curr_state->node->node_number;\
	if (r_other_state == NULL){\
		a3 = -1;\
		a4 = -1;\
	}\
	else {\
		a3 = r_other_state->proc->proc_number;\
		a4 = r_other_state->node->node_number;\
	}\
	generate_hash_table_entry (r_curr_state, a1, a2, r_other_state, a3, a4);\
	cdata = (int *) pblHtLookup (state_hash_table, (void *) hash_table_entry, sizeof (int)*1000);\
	if (!cdata){\
		pblHtInsert(state_hash_table, (void*)hash_table_entry, sizeof(int)*1000, (void*)hash_table_entry);\
	}else {\
                pblHtInsert (lasso_hash_table, (void *)&stored_current_lasso_long, sizeof (unsigned long long), (void *) &stored_current_lasso_long);\
		number_of_lasso_runs++;\
		return;\
	}\
}

#define CHECK_HASH_TABLE()\
{\
	int * temp_entry;\
	int i;\
	generate_hash_table_entry ();\
	cdata = (int *) pblHtLookup (state_hash_table, (void *) hash_table_entry, sizeof (int)*(MAX_STATE_SIZE * MAX_NUM_PROCESS));\
	if (!cdata){\
		pblHtInsert(state_hash_table, (void*)hash_table_entry, sizeof(int)*(MAX_STATE_SIZE * MAX_NUM_PROCESS), (void*)hash_table_entry);\
	}else {\
		number_of_lasso_runs++;\
	}\
}
                //pblHtInsert (lasso_hash_table, (void *)&stored_current_lasso_long, sizeof (unsigned long long), (void *) &stored_current_lasso_long);\

#define CHECK_RULE()\
{\
	check_rule();\
	if (found_second == 1) {\
		printf ("property is satisfied\n");\
		exit(1);\
	}\
}
