
struct cfg_edge
{
	int node[2];	
	int type; // 1 for data, 2 for control
	struct cfg_edge * next;
};

struct cfg_node
{
	int node_number;
	bool marked;
	tree insn;
	struct cfg_edge * outgoing_edges;
	struct cfg_edge * incoming_edges;
};


struct proc_cfg
{
	struct cfg_node * * cfg_array;
	int total_insns;
	char * proc_name;
	int proc_number;
	tree proc;
	struct var_list * vars;
	int num_vars;
	struct proc_cfg * next;
};



struct p_edge
{
	int node[2];	
	int type; // 1 for data, 2 for control
	struct p_edge * next;
};

struct p_node
{
	int node_number;
	bool marked;
	bool has_goto_statement_marked;
	tree insn;
	struct p_edge * outgoing_edges;
	struct p_edge * incoming_edges;
};

