pblHashTable_t * state_hash_table = NULL;
int * r_hash_table_entry = NULL;
int * cdata = NULL;
struct cfg_node * curr_cfg_node = NULL;
struct proc_cfg * curr_proc = NULL; 
s_state * r_curr_state = NULL;
s_mem_loc_list last_allocated_memory = NULL;
s_mem_loc_list last_allocated_heap = NULL;
extern struct globals_list * globals_list;
extern int int_global_seed;
int seed = 100;
s_process * main_process = NULL;
s_process * child_process = NULL;
s_process * current_process = NULL;
int found_first=0, found_second=0;

#define FIRST_NODE_NUMBER 28
//#define SECOND_NODE_NUMBER 69
#define SECOND_NODE_NUMBER 73
void allocate_memory_for_records (tree var, int kind);
void execute ();
void start_execution(void);
s_value * create_value_structure (tree var);
void clone_memory (s_state * curr_state, s_state * next_state);
void clone_heap (s_state * curr_state, s_state * next_state);
void clone_state (s_state *curr_state, s_state *next_state);
s_mem_loc_list find_lvalue (s_state* curr_state, tree l_var);
s_value * find_rvalue (s_state * curr_state, tree r_var);
s_value * create_value_structure_for_pointer (int malloc_size, tree type);


struct array_ref {
	tree op1;
	int kind; /* 0: ARRAY_REF, 1: COMP_REF */
	struct array_ref * next;
};

struct array_size {
	int size;
	struct array_size * next;
};
