/*This File defines data structures corresponding to memory location 
  Which involves variable and value stored in the memory location */
#define G 1
#define L 2
enum my_kind {INT_KIND, FLOAT_KIND, BOOL_KIND, MEM_KIND, HEAP_KIND};

struct my_value {
	union {
		int 	int_val; 
		float	float_val;
		bool	bool_val;
		s_mem_loc_list mem_val;
		s_mem_loc_list heap_val;
	} value;
	enum my_kind kind;
};

typedef struct my_value s_value;

struct my_memory {
	int index; //haven't used this field so far, but will be useful when consider &var
	int kind; //G = 1 for global, L = 2 for local
	tree var;
	int points_to_index;
	s_value * val;
	s_mem_loc_list next_struct;	
}; 

typedef struct my_memory s_mem_loc;
